
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>nova api源码分析（一） / 憋错料</title>

    <meta name="description" content="nova api源码分析（一） 说明: 源码版本:H版 参考文档:http://www.choudan.net/2013/12/09/OpenStack-WSGI-APP%E5%AD%A6%E4%B9%A0.html 一.前奏 nova api本身作为一个WSGI服务器,对外提供HTTP请求服务,对内调用nova的其他模块响应相应的HTTP请求.分为两大部分,一是创建该服务器时加载的app,这个用来处理请求:一是服务器本身的启动与运行. 目录结构如下: 首先,nova api是作为一个WSGI服务,肯定要查看它的启动过程,查看">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">nova api源码分析（一）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>说明：</p>
<p>源码版本：H版</p>
<p>参考文档：<a href="http://www.choudan.net/2013/12/09/OpenStack-WSGI-APP%E5%AD%A6%E4%B9%A0.html" rel="external nofollow noreferrer">http://www.choudan.net/2013/12/09/OpenStack-WSGI-APP%E5%AD%A6%E4%B9%A0.html</a></p>
<p>一、前奏</p>
<p>nova api本身作为一个WSGI服务器，对外提供HTTP请求服务，对内调用nova的其他模块响应相应的HTTP请求。分为两大部分，一是创建该服务器时加载的app，这个用来处理请求；一是服务器本身的启动与运行。</p>
<p>　　目录结构如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzY0MDgyNC8yMDE0MTAvMTMyMDI2MDI1NjA5MDQ1LmpwZw==.jpg" /></p>
<p>首先，nova api是作为一个WSGI服务，肯定要查看它的启动过程，查看启动脚本/etc/init.d/openstack-nova-api(使用service命令实际在调用/etc/init.d文件夹下的脚本文件)。在/etc/init.d/openstack-nova-api文件中，start选项代表调用脚本/usr/bin/nova-api，如下：</p>
<p>/usr/bin/nova-api</p>
<pre>import sys
from nova.cmd.api import main
if __name__ == "__main__":
　　sys.exit(main())</pre>
<p>接着，</p>
<p>/nova/cmd/api.py (文件位置为/usr/lib/python2.6/site-packages，此处及下面均省略）</p>
<pre>def main():
    config.parse_args(sys.argv)
    logging.setup("nova")
    utils.monkey_patch()

    launcher = service.process_launcher()
    for api in CONF.enabled_apis:
        should_use_ssl = api in CONF.enabled_ssl_apis
        if api == ‘ec2‘:
            """为了与ec2兼容"""
            server = service.WSGIService(api, use_ssl=should_use_ssl,
                                         max_url_len=16384)
        else:
            server = service.WSGIService(api, use_ssl=should_use_ssl) 【1】
        launcher.launch_service(server, workers=server.workers or 1)【2】
    """当前进程处于等待状态"""
　　launcher.wait()</pre>
<p>二、分析【1】处：主要是WSGIService对象的创建</p>
<p>/nova/service.py</p>
<pre>WSGIService类：
def __init__(self, name, loader=None, use_ssl=False, max_url_len=None):
    self.name = name
    self.manager = self._get_manager()
    self.loader = loader or wsgi.Loader()
    self.app = self.loader.load_app(name)
    self.host = getattr(CONF, ‘%s_listen‘ % name, "0.0.0.0")
    self.port = getattr(CONF, ‘%s_listen_port‘ % name, 0)
    self.workers = getattr(CONF, ‘%s_workers‘ % name, None)
    self.use_ssl = use_ssl
    """封装了wsgi.py中的server"""
    self.server = wsgi.Server(name,
                              self.app,
                              host=self.host,
                              port=self.port,
                              use_ssl=self.use_ssl,
                              max_url_len=max_url_len)
    # Pull back actual port used
    self.port = self.server.port
    self.backdoor_port = None</pre>
<p>/nova/wsgi.py</p>
<pre>Loader类：
def __init__(self, config_path=None):
　　"""试图寻找api-paste.ini配置文件"""
　　self.config_path = None

　　config_path = config_path or CONF.api_paste_config
　　if not os.path.isabs(config_path):
　　　　self.config_path = CONF.find_file(config_path)
　　elif os.path.exists(config_path):
　　　　self.config_path = config_path

　　if not self.config_path:
　　　　raise exception.ConfigNotFound(path=config_path)

def load_app(self, name):
　　try:
　　　　LOG.debug("Loading app %(name)s from %(path)s",
                {‘name‘: name, ‘path‘: self.config_path})
　　　　return deploy.loadapp("config:%s" % self.config_path, name=name)
　　except LookupError as err:
　　　　LOG.error(err)
　　　　raise exception.PasteAppNotFound(name=name, path=self.config_path)    </pre>
<p>此处关于app的具体加载过程见"nova api源码分析（二）"</p>
<p>三、分析【2】处：主要是WSGIService的启动</p>
<p>/nova/openstack/common/service.py</p>
<pre>ProcessLauncher类：
def launch_service(self, service, workers=1):
　　wrap = ServiceWrapper(service, workers)

　　LOG.info(_(‘Starting %d workers‘), wrap.workers)
　　"""循环启动workers数目的子进程"""
　　while self.running and len(wrap.children) &lt; wrap.workers:
　　　　self._start_child(wrap)

def _start_child(self, wrap):
　　...
　　"""创建子进程"""
　　pid = os.fork()
　　if pid == 0:

　　　　status = 0
　　　　try:
　　　　　　"""子进程进行处理"""
　　　　　　self._child_process(wrap.service)
　　　　except SignalExit as exc:
　　　　　　signame = {signal.SIGTERM: ‘SIGTERM‘,
                    signal.SIGINT: ‘SIGINT‘}[exc.signo]
　　　　　　LOG.info(_(‘Caught %s, exiting‘), signame)
　　　　　　status = exc.code
　　　　except SystemExit as exc:
　　　　　　status = exc.code
　　　　except BaseException:
　　　　　　LOG.exception(_(‘Unhandled exception‘))
　　　　　　status = 2
　　　　finally:
　　　　　　"""出现异常停掉服务"""
　　　　　　wrap.service.stop()
　　　　"""子进程退出"""
　　　　os._exit(status)

　　LOG.info(_(‘Started child %d‘), pid)
　　wrap.children.add(pid)
　　self.children[pid] = wrap
　　return pid

def _child_process(self, service):
　　...
　　launcher = Launcher()
　　launcher.run_service(service)</pre>
<p>/nova/openstack/common/service.py</p>
<pre>Launcher类：
def __init__(self):
    self._services = threadgroup.ThreadGroup()
    self.backdoor_port = eventlet_backdoor.initialize_if_enabled() 

@staticmethod
def run_service(service):
    service.start()
    service.wait()</pre>
<p>由于这里的service是WSGIService对象，如下：</p>
<p>/nova/service.py</p>
<pre>WSGIService类：
def start(self):    if self.manager:
        self.manager.init_host()
        self.manager.pre_start_hook()
        if self.backdoor_port is not None:
            self.manager.backdoor_port = self.backdoor_port
    self.server.start()
    if self.manager:
        self.manager.post_start_hook()

def wait(self):
    self.server.wait()</pre>
<p>/nova/wsgi.py</p>
<pre>Server类：
def start(self):
    ...
    wsgi_kwargs = {
        ‘func‘: eventlet.wsgi.server,
        ‘sock‘: self._socket,
        ‘site‘: self.app,
        ‘protocol‘: self._protocol,
        ‘custom_pool‘: self._pool,
        ‘log‘: self._wsgi_logger,
        ‘log_format‘: CONF.wsgi_log_format
        }

    if self._max_url_len:
        wsgi_kwargs[‘url_length_limit‘] = self._max_url_len
    """创建一个green thread，运行func函数，在其中传入后面的参数。此处为调用eventlet.wsgi.server函数，传入sock=self._socket等参数到server函数中。其中eventlet.wsgi.server函数负责启动一个wsgi服务器程序接受客户端发来的请求，可以参考：<a href="http://eventlet.net/doc/modules/wsgi.html?highlight=wsgi.server#eventlet.wsgi.server" rel="external nofollow noreferrer">http://eventlet.net/doc/modules/wsgi.html?highlight=wsgi.server#eventlet.wsgi.server</a>"""
    self._server = eventlet.spawn(**wsgi_kwargs)

def wait(self):
    try:
        """green thread阻塞等待"""
        self._server.wait()
    except greenlet.GreenletExit:
        LOG.info(_("WSGI server has stopped."))</pre>
<p>总结：</p>
<p>我们可以通过pstree命令查看系统中进程的子进程数，发现nova-api进程中有一个主进程，其子进程数目为一个ec2，一个metadata，有workers数目的osapi_compute(其中workers可以通过/etc/nova/nova.conf中osapi_compute_workers选项设置)。然后通过ps &ndash;Lf查看每个进程的线程数目，发现其均为单线程。由此可以看出，整个server的创建和启动过程就是，主进程产生若干的子进程，子进程使用green thread启动wsgi server并等待服务。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 10:05:01 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>nova api源码分析（一）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xrr674.html" rel="bookmark">nova api源码分析（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载于:http://www.it165.net/pro/html/201407/17020.html (经过部分编辑) 一.使用到的库或组件如下: paste.deploy 用来解析/etc/nova/api-paste.ini文件,加载用于服务的wsgi app.它的功能有: 1.api-paste.ini中配置多个wsgi app,deploy可根据传入的app name加载指定的wsgi app: deploy.loadapp(&quot;config:/etc/nova/api-paste.in			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLOWkv4.html" rel="bookmark">&num;tensorflow object detection api 源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 Tensorflow 推出的 Object Detection API是一套抽象程度极高的目标检测框架,可以快速用于生产部署.但网络上大多数相关的中英文文章均只局限于应用层面的分析,对于该套框架的算法实现源码没有针对性的分析文章.对于选择tensorflow作为入门框架的深度学习新手,不仅应注重于算法本身的理解,更应注重算法的编码实现.本人也是刚入门深度学习的新手,深深困扰于tensorflow 目标检测框架的抽象代码,因此花费了大量时间分析源码,希望能对博友有益,同时受限于眼界,文章中必			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bxGpp4.html" rel="bookmark">requests库核心API源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				requests库是python爬虫使用频率最高的库,在网络请求中发挥着重要的作用,这边文章浅析requests的API源码. 该库文件结构如图: 提供的核心接口在__init__文件中,如下: from . import utils from . import packages from .models import Request, Response, PreparedRequest from .api import request, get, head, post, patch, put,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWbgPr4.html" rel="bookmark">Nova client源码分析---nova list命令</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				个人见解,可能会有错误.刚刚开始学习nova,就先从api入手学习吧. 1.D:\代码\python-novaclient\python-novaclient\novaclient\v1_1\shell.py,最上边怎么调用不太清楚了,先从这里开始. def do_list(cs, args):     &quot;&quot;&quot;List active servers.&quot;&quot;&quot;     imageid = None     flavorid = None     #查			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Z26lJ3.html" rel="bookmark">nova创建虚拟机源码分析系列之七  传入参数转换成内部id</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一篇博文将nova创建虚机的流程推进到了/compute/api.py中的create()函数,接下来就继续分析. 在分析之前简单介绍nova组件源码的架构.以conductor组件为例: 每个组件都会有这三个文件:api.py rpcapi.py manager.py. api.py              conductor实现自身功能的文件 rpcapi.py         conductor提供给其他组件通过消息队列调用的接口函数 manager.py    其他组件通过消息队列调			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXnDaz3.html" rel="bookmark">jQuery-1&period;9&period;1源码分析系列（十六）ajax&mdash;&mdash;响应数据处理和api整理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ajax在得到请求响应后主要会做两个处理:获取响应数据和使用类型转化器转化数据 a.获取响应数据 获取响应数据是调用ajaxHandleResponses函数来处理. ajaxHandleResponses的功能有: - 为jqXHR设置所有responseXXX字段(值便是响应数据) - 找到正确的dataType (在content-type和预期的dataType两者中的一个) - 返回正确的响应数据 我们看一个响应数据的格式: responses = { text: &quot;{&quot;co			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pNlOJ0.html" rel="bookmark">ABP源码分析三十六：ABP&period;Web&period;Api</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这里的内容和ABP 动态webapi没有关系.除了动态webapi,ABP必然是支持使用传统的webApi.ABP.Web.Api模块中实现了一些同意的基础功能,以方便我们创建和使用asp.net webApi. AbpApiController:这是一个抽象基类,继承自ApiController,是AB WebApi系统中所有controller的基类.如下图中,其封装了ABP核心模块中提供的大多数的功能对象.同时实现了一些公共的方法.它有四个派生类:DynamicApiController&lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6x7ny3.html" rel="bookmark">Zepto源码分析之二~三个API</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于时间关系:本次只对这三个API($.camelCase.$.contains.$.each)方法进行分析 第一个方法变量转驼峰:$.camelCase('hello-world-welcome'); 源码: var camelize; /** * 字符串替换 * 使用replace第二个参数带回调 */ camelize = function(str) { return str.replace(/-+(.)?/g, function(match, chr) { return chr ? ch			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rnn873.html" rel="bookmark">Kubernetes 源码分析 -- API Server之编解码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				--------------------- 作者:weixin_34037977 来源:CSDN 原文:https://blog.csdn.net/weixin_34037977/article/details/87058105 在Kubernetes源码分析-- API Server之API Install篇中,我们了解到K8S可以支持多版本的API,但是Rest API的不同版本中接口的输入输出参数的格式是有差别的,Kubernetes是怎么处理这个问题的呢?另外Kubernetes支持ya			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V0b91kM.html" rel="bookmark" class="title">Photoshop脚本 &amp;gt&semi; 遍历系统中的所有字体</a>
					<div>
						源自:http://coolketang.com/tutorials/menu1lesson7.php 本节将演示如何使用脚本,查看系统中所有可用字体.首先创建一个空白的脚本文档,并保存在硬盘上某个位 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MEDGZ4.html" rel="bookmark" class="title">dubbo学习之dubbo管理控制台装配及集成zookeeper集群部署（1）【转】</a>
					<div>
						dubbo管理控制台开源部分主要包含:路由规则,动态配置,服务降级,访问控制,权重调整,负载均衡,等管理功能. 1.下载dubbo 地址:http://code.alibabatech.com/mvn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgLN8R0.html" rel="bookmark" class="title">jquery事件之事件</a>
					<div>
						事件名 说明 语法 (events 事件类型,data数据,handler 事件处理函数,selector 选择器) blur() 获得失去鼠标光标焦点事件 jQueryObject.blur( [  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8Q7n0.html" rel="bookmark" class="title">实习日记 怎么让菜单栏默认打开</a>
					<div>
						&lt;li&gt; &lt;h3&gt;&lt;i class=&quot;fa fa-fw fa-cog&quot; &gt;&lt;/i&gt;系统设置&lt;/h3&gt; &lt;ul cl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49bvaAM.html" rel="bookmark" class="title">bash中的循环</a>
					<div>
						until CONDITION; do 循环体 done 进入条件:false 退出条件:true 示例:求100以内所有正整数之和 [[email protected] shell]# vim su ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg5QNN3.html" rel="bookmark" class="title">数据泵在本地导出数据到远程数据库中</a>
					<div>
						local_db 安装在suselocal_db的tnsname       (DESCRIPTION =(ADDRESS = (PROTOCOL = TCP)(HOST = 192.168.31.1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kZzYEM.html" rel="bookmark" class="title">《C&plus;&plus; Primer Plus》第9章 内存模型和名称空间 学习笔记</a>
					<div>
						C++鼓励程序员在开发程序时使用多个文件.一种有效的组织策略是,使用头文件来定义用户类型,为操纵用户类型的函数提供函数原型,并将函数定义放在一个独立的源代码文件中.头文件和源代码文件一起定义和实现了用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZqDjm0.html" rel="bookmark" class="title">winsock编程-入门</a>
					<div>
						client: #include&lt;winsock2.h&gt; #include&lt;cstdio&gt; #pragma comment(lib,&quot;ws2_32.lib&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvKyQ3.html" rel="bookmark" class="title">MYSQL的学习&lpar;六&rpar;Mysql的连接</a>
					<div>
						有关Mysql的内连接,外连接,交叉连接 1.内连接:将两个表中满足连接条件的行组合起来作为结果集------inner 语法:select 列1,列2,列n from 表一  inner join  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MobVJw4.html" rel="bookmark" class="title">UML学习之类图</a>
					<div>
						参考链接: http://www.uml.org.cn/oobject/201211231.asp  深入浅出UML http://www.open-open.com/lib/view/open132 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLrw9v3.html" rel="bookmark" class="title">spring中applicationContex&period;xml文件</a>
					<div>
						&lt;mvc:resources mapping=&quot;/js/**&quot; location=&quot;/WEB_INF/js&quot;/&gt;主要用于静态资源的访问. 使用spr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGDklV0.html" rel="bookmark" class="title">织梦模板dedecms pc端首页必备调用代码</a>
					<div>
						&lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/html; charset=gb2312&quot; /&gt;&lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02Xngo4.html" rel="bookmark" class="title">iOS图片拉伸的三种方法</a>
					<div>
						方法一: iOS中有个叫端盖(end cap)的概念,用来指定图片中的哪一部分不用拉伸,上下左右不需要被拉伸的边缘就称为端盖. 1 // use resizableImageWithCapInsets ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KjNlrM.html" rel="bookmark" class="title">Aqua data studio中文乱码</a>
					<div>
						1.文件-选项-一般-外观-编辑器字体.文本结果字体.网格结果字体,均设置为“宋体”, 2.文件-选项-一般-“:语句分隔符”选择 3.先选择一个数据库,然后选择[服务器]/[服务器属性]/[高级], ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49vqyAM.html" rel="bookmark" class="title">&lbrack;Scala&rsqb; Java执行Shell命令</a>
					<div>
						Methods ProcessBuilder.start() 和 Runtime.exec() 方法都被用来创建一个操作系统进程(执行命令行操作),并返回 Process 子类的一个实例,该实例可用来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVRYowM.html" rel="bookmark" class="title">linux -- ubuntu 14&period;10开机出现错误&OpenCurlyDoubleQuote;Error found when loading &sol;root&sol;&period;profile&rdquo;解决</a>
					<div>
						修改完root权限自动登录后,发现开机出现以下提示: Error found when loading /root/.profile stdin:is not a tty ………… 解决方法:在终端中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rQzPX0.html" rel="bookmark" class="title">Android中万能的适配器的详细讲解</a>
					<div>
						Android中万能的适配器的详细讲解 在Android开发中,适配器的用处是非常大的,尤其是效率优化方面.除了使用ViewHolder复用View之外,如果存在很多的ListView或者是一个Lis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e6Jkv3.html" rel="bookmark" class="title">revit 二次开发之基于族获得实例</a>
					<div>
						Revit并没有直接开放基于族获取实例元素的过滤器.不过有两个相关的过滤器,一个是FamilySymbolFilter(ElementId familyId),可以基于族ID过滤出所有这个族的族类型, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVWDod0.html" rel="bookmark" class="title">再谈Weiphp公众平台开发&mdash;&mdash;1、成语接龙插件</a>
					<div>
						易错点,注意插件的命名 1.创建插件.在weiphp管理后台创建成语接龙插件,勾选安装后立即启用,不需要配置项和管理列表.点&quot;确定&quot;完成插件的创建. 2.安装插件. 3.检测插件是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGnwDy4.html" rel="bookmark" class="title">MySql批量更新方法</a>
					<div>
						准备数据 表 user(用户).dept(部门) 1:更新符合单个条件的某个字段的一条数据 update user u set u.name = '测试' where u.id = &quot;&qu ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
